Page MenuHomePhabricator

Punctuation incorrectly placed for English text in banners on right-to-left written wikis
Open, NormalPublic

Description

Author: incarus6

Description:
Some advertisings seems to be broken on wikis like WP:FA,
see http://img831.imageshack.us/img831/2601/werbungwpfa.png


Version: unspecified
Severity: normal

Details

Reference
bz45941

Event Timeline

bzimport raised the priority of this task from to Normal.Nov 22 2014, 1:33 AM
bzimport set Reference to bz45941.
bzimport added a subscriber: Unknown Object (MLST).
bzimport created this task.Mar 9 2013, 6:32 PM

incarus6 wrote:

Advertising on WP:FA

Attached:

I have updated the banner in question with the Farsi translation [1]. This should have resolved the particular issue shown in the attachment, occurring when viewing fawiki with Farsi as user language, as the reporter appears to have. Any Meta admin could have done so, as described on the translation page linked from the banner [2].

As I understand it, the issue was not that the banner displayed in English (although of course it is preferable to have it available in the local language), but rather that the English banner displayed in a broken way - "?How should...", ".(Comment on proposals...", etc.
It's worth noting the English-language version of this banner displays fine on hewiki, another right-to-left wiki [3], when selecting English as user language. And on the other hand, for some reason selecting a specific banner does not seem to work at all to me on either fawiki [4] or arwiki [5]. Same for other banners, e.g. compare [6] and [7].

This suggests to me that this is a general issue with the display of banners in *some* RTL wikis, in particular when there is no local translation available and the CentralNotice fallback logic selects a LTR version to display, as it was the case here. I'll also note that there is an open bug which may be related [8].

Also, it is my understanding that Bugzilla is for fixes in the software running on Wikimedia sites, or their configuration, rather than for requesting content changes on these wikis (as in this case). In that regard, this bug is better understood as reporting a general problem. For these reasons, I am hesitant to claim the fame of having resolved this bug solely based on my wiki edits that fixed this particular banner. So I am resetting the assignee to default.

[1] https://meta.wikimedia.org/wiki/Special:NoticeTemplate/view?template=FDCpropreview20031&wpUserLanguage=fa

[2] https://meta.wikimedia.org/wiki/FDC_portal/CentralNotice2013-1

[3] https://he.wikipedia.org/w/index.php?banner=FDCpropreview20031&uselang=en (note that you have to be logged in to see this and the other banner examples)

[4] https://fa.wikipedia.org/w/index.php?banner=FDCpropreview20031&uselang=en

[5] https://ar.wikipedia.org/w/index.php?banner=FDCpropreview20031&uselang=en

[6] https://ar.wikipedia.org/w/index.php?banner=IndivdualGrantsA

[7] https://he.wikipedia.org/w/index.php?banner=IndivdualGrantsA

[8] https://bugzilla.wikimedia.org/show_bug.cgi?id=21778 "BiDi issue in RTL wikis at site notice with LTR text ending with Unicode characters with neutral directional"

(In reply to comment #2)

This suggests to me that this is a general issue with the display of banners
in *some* RTL wikis, in particular when there is no local translation available

Sidenote: The wrong placement of punctuation marks also happens in other [intentionally] unlocalized strings on RTL wikipages and is not specific to CentralNotice but probably lower in the core stack, e.g. my username "AKlapper (WMF)" is displayed as "(AKlapper (WMF" on https://he.wikipedia.org .

(In reply to comment #3)

(In reply to comment #2)

This suggests to me that this is a general issue with the display of banners
in *some* RTL wikis, in particular when there is no local translation available

Sidenote: The wrong placement of punctuation marks also happens in other
[intentionally] unlocalized strings on RTL wikipages and is not specific to
CentralNotice but probably lower in the core stack, e.g. my username
"AKlapper
(WMF)" is displayed as "(AKlapper (WMF" on https://he.wikipedia.org .

That looks similar to https://bugzilla.wikimedia.org/show_bug.cgi?id=45932 , btw.

Bug 49255, bug 45941, bug 45932 might all have the same underlying reason. Anybody who knows the codebase better, feel free to mark as a duplicates.

mwalker wrote:

I wonder if adding a <span lang=""></span> to banner messages would help... I shall try that at some point; writing down here so I dont forget.

incarus6 wrote:

As you can see in the screenshot above, not only brackets are affected by this issue @ Andre. I reverted your misleading changes back to the old.

atgo added a subscriber: atgo.Jan 28 2015, 10:13 PM

Does anyone know if this is still a thing?

It is totally still a thing.

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptJul 16 2015, 6:27 PM
Amire80 moved this task from Backlog to Other on the RTL board.Jul 16 2015, 6:27 PM
awight added a project: good first bug.
awight added a subscriber: awight.
Meno25 removed a subscriber: Meno25.Feb 8 2016, 7:34 PM
atgo removed a subscriber: atgo.Mar 30 2016, 10:05 PM
Restricted Application added a subscriber: TerraCodes. · View Herald TranscriptOct 2 2016, 11:06 AM
Ashutosh1206 removed Ashutosh1206 as the assignee of this task.Oct 2 2016, 1:31 PM
Ashutosh1206 added a subscriber: Ashutosh1206.

Are there any potential workarounds we can use within the banner code to solve this problem?

<div dir="ltr" lang="en"> and so on. Or &lrm; sprinkled liberally near punctuation characters.

Huji added a subscriber: Huji.Jan 27 2017, 1:42 PM

But if you use those in the original (English) text and it is translatable, then one might incorrectly include them in the translation too, causing problem.

I would say the real solution is to engage users who can translate such banners, before they go live.

mmodell removed a subscriber: awight.Jun 22 2017, 9:39 PM
Amire80 moved this task from Untriaged to RTL on the I18n board.Feb 28 2018, 12:33 PM